'========================================================
'  Name:    SviUpdate.vbs
'  Version: 1.0
'  Date  :  11/10/2003
'  Author:  Werner Bloos
'  Comment: Update *.svi files with given informations.
'========================================================

Option Explicit
Dim i
Dim result
Dim strSourceFolder
Dim strThumbnailFolder
Dim strInfoFolder
Dim strUrlFolder

Dim strTargetFolder
Dim strTxt2search
Dim strOutputFileExtension
Dim strOutputFile
Dim strInfo
Dim strReferenzInfo
Dim strURL
Dim strReferenzURL
Dim strThumbnail
Dim strReferenzThumbnail
Dim strThumbnailFileExt
Dim strInputSVI
Dim strOutputSVI
Dim strInputFileNameNoExt
Dim strSearchFileName
Dim strInfoFileExt
Dim strURLFileExt

Dim logena
Dim strLogPath
Dim strLogFile

Dim lngFileLen
Dim lngStrLen
Dim lngPos
Dim lngActualPos
Dim lngNewPos
Dim lngStringLenght
Dim lngBytesToAdd
Dim lngSeparation
Dim lngAspectRatioX
Dim lngAspectRatioY
Dim bytStereoFormat

Dim objFSO
Dim objFSI
Dim objFolder
Dim colFiles
Dim objFile
Dim objLogText
Dim objOutputFile
Dim objInputFile
Dim strOutputFileName
Dim strInputFileName

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'~~~ change these settings when needed ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
strSourceFolder 		= ".\"			' source folder where the *.svi files can be found
strThumbnailFolder		= ".\thumb\"		' thumbnail folder
strReferenzThumbnail		= "thumb"		' Thumbnail reference filename
strInfoFolder			= ".\info\"		' INFO folder 
strReferenzInfo			= "info"		' INFO reference filename
strInfoFileExt 			= ".txt"		' INFO file extension
strUrlFolder			= ".\url\"		' URL folder
strReferenzURL			= "url"			' URL reference filename
strURLFileExt			= ".txt"		' URL file extension
strThumbnailFileExt		= ".jpg"		' thumbnail file extension

logena				= 0			' enable / disable logfile (1/0)
strLogPath			= ".\log\"		' log folder
strLogFile			= "svi.log"		' log file

bytStereoFormat			= 4			' Stereoformat: mono: 0 / IntR: 1 / IntL: 2 / SbSR: 3 / SbSL: 4 /OUR: 5 / OUL 6
lngSeparation			= 0			' Separation
lngAspectRatioX			= 4			' AspectRatioX
lngAspectRatioY			= 3			' AspectRatioY

strTargetFolder			= ".\"			' output folder
strTxt2search 			= ".svi"		' search string - preset: the extension ".svi"
strOutputFileExtension 	= 	".svi"			' output extension
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Const ForReading	= 1
Const ForWriting	= 2
Const ForAppending	= 8
Set objFSI	= CreateObject("Scripting.FileSystemObject")
Set objFSO	= CreateObject("Scripting.FileSystemObject")
Set objFolder	= objFSO.GetFolder(strSourceFolder)
Set colFiles	= objFolder.Files

For Each objFile in colFiles
	If InStr(objFile.Name, strTxt2search) <> 0 Then
		strOutputFile = strTargetFolder & Left(objFile.Name, (Len(objFile.Name) - 4)) & strOutputFileExtension
		strInputFileName = objFile.Name
		strInputFileNameNoExt = Left(objFile.Name, (Len(objFile.Name) - 4))
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "strOutputFile = " & strOutputFile & Chr(13) & Chr ( 10)
		   objLogText.Write "strInputFileName = " & strInputFileName & Chr(13) & Chr ( 10)
		   objLogText.Write "strInputFileNameNoExt = " & strInputFileNameNoExt & Chr(13) & Chr ( 10)
		   objLogText.Close
		End if
		
		' read original SVI file
		Set objInputFile = objFSI.OpenTextFile(strInputFileName, ForReading)
		strInputSVI = objInputFile.ReadAll
		objInputFile.Close		
		Set objInputFile = Nothing
		' hmm VBScript can't read binary files ... so the following method is needed to read tese files
		lngFileLen = Len(strInputSVI)
		strInputSVI = ""
		Set objInputFile = objFSI.OpenTextFile(strInputFileName, ForReading,-2)
		For i = 1 to lngFileLen
		  strInputSVI = strInputSVI & (objInputFile.Read(1))
		Next
		objInputFile.Close
					
		' search for filename within SVI file and calculate position where INFO stats 
		lngPos = InStr(1,strInputSVI,strInputFileNameNoExt,1) - 1
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "lngPos = " & lngPos & Chr(13) & Chr (10)
		   objLogText.Close
		End If
		
		lngNewPos = lngPos + ((Asc (Mid(strInputSVI,lngPos,1)) * 256) + (Asc((Mid(strInputSVI,lngPos - 1,1)))))
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "lngNewPos = " & lngNewPos & Chr(13) & Chr (10)
		   objLogText.Close
		End If
		
		lngActualPos = lngNewPos
		lngNewPos = lngActualPos + ((Asc (Mid(strInputSVI,lngActualPos + 2,1)) * 256) + (Asc((Mid(strInputSVI,(lngActualPos + 1),1))))) + 2
		lngActualPos = lngNewPos
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "lngPos = " & lngPos & Chr(13) & Chr ( 10)
		   objLogText.Write "lngNewPos = " & lngNewPos & Chr(13) & Chr (10)
		   objLogText.Write "lngActualPos = " & lngActualPos & Chr(13) & Chr ( 10)
		   objLogText.Close
		End If
		
		' copy first Bytes to output string up to position where INFO starts
		strOutputSVI = Left(strInputSVI,lngActualPos)
		
		' search and open corresponding INFO file
		result = false
		strSearchFileName = strInputFileNameNoExt
		Do While result = false
		 If objFSI.FileExists(strInfoFolder & strSearchFileName & strInfoFileExt) Then
		  result = true
		 Else
		  If Len(strSearchFileName) > 3 Then
		   strSearchFileName = Left(strSearchFileName,Len(strSearchFileName) - 1) 
		  Else
		   strSearchFileName = strReferenzInfo
		   result = true
		  End if
		 End if
		loop
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "strSearchFileName INFO = " & strSearchFileName & Chr(13) & Chr ( 10)
		   objLogText.Close
		End If
		
		Set objInputFile = objFSI.OpenTextFile(strInfoFolder & strSearchFileName & strInfoFileExt, ForReading)
		strInfo = objInputFile.ReadAll
		objInputFile.Close		
		Set objInputFile = Nothing
		lngStrLen = Len(strInfo)
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "strInfo = " & strInfo & Chr(13) & Chr ( 10)
		   objLogText.Write "lngStrLen = " & lngStrLen & Chr(13) & Chr ( 10)
		   objLogText.Close
		End If
		
		' add lenght of Infostring to output file (2 bytes)
		strOutputSVI = strOutputSVI & Chr(lngStrLen - (Int(lngStrLen/256)*256)) & Chr(Int(lngStrLen/256))
		
		' add info string
		strOutputSVI = strOutputSVI & strInfo
		
		' search and open corresponding URL file
		result = false
		strSearchFileName = strInputFileNameNoExt 
		Do While result = false
		 If objFSI.FileExists(strURLFolder & strSearchFileName & strURLFileExt) Then
		  result = true
		 Else
		  If Len(strSearchFileName) > 3 Then
		   strSearchFileName = Left(strSearchFileName,Len(strSearchFileName) - 1) 
		  Else
		   strSearchFileName = strReferenzURL
		   result = true
		  End if
		 End if
		loop
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "strSearchFileName URL = " & strSearchFileName & Chr(13) & Chr ( 10)
		   objLogText.Close
		End If
		
		Set objInputFile = objFSI.OpenTextFile(strURLFolder & strSearchFileName & strURLFileExt, ForReading)
		strURL = objInputFile.ReadAll
		objInputFile.Close		
		Set objInputFile = Nothing
		lngStrLen = Len(strURL)
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "strURL = " & strURL & Chr(13) & Chr ( 10)
		   objLogText.Write "lngStrLen = " & lngStrLen & Chr(13) & Chr ( 10)
		   objLogText.Close
		End If
		
		' add lenght of URLstring to output file (2 bytes)
		strOutputSVI = strOutputSVI & Chr(lngStrLen - (Int(lngStrLen/256)*256)) & Chr(Int(lngStrLen/256))
		
		' add URLstring
		strOutputSVI = strOutputSVI & strURL
		
		' add stereoformat to output file
		strOutputSVI = strOutputSVI & Chr(bytStereoFormat)
		
		' add separation to output file
		strOutputSVI = strOutputSVI & Chr(lngSeparation	- (Int(lngSeparation/256)*256)) & Chr(Int(lngSeparation/256))
		
		' add AspectRatioX to output file
		strOutputSVI = strOutputSVI & Chr(lngAspectRatioX - (Int(lngAspectRatioX/256)*256)) & Chr(Int(lngAspectRatioX/256))
		
		' add AspectRatioY to output file
		strOutputSVI = strOutputSVI & Chr(lngAspectRatioY - (Int(lngAspectRatioY/256)*256)) & Chr(Int(lngAspectRatioY/256))
		
		' search filelenght,duration and flags within original SVI file
		lngNewPos = lngActualPos + Asc(Mid(strInputSVI,lngActualPos+1,1))+(Asc(Mid(strInputSVI,lngActualPos+2,1))*256) + 2
		lngActualPos = lngNewPos
		lngNewPos = lngActualPos + Asc(Mid(strInputSVI,lngActualPos+1,1))+(Asc(Mid(strInputSVI,lngActualPos+2,1))*256) + 2
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "lngActualPos (Info)= " & lngActualPos & Chr(13) & Chr ( 10)
		   objLogText.Write "lngNewPos (URL)= " & lngNewPos & Chr(13) & Chr (10)
		   objLogText.Close
		End If
		
		strOutputSVI = strOutputSVI & Mid(strInputSVI,lngNewPos+8,21)
		
		' search and open corresponding thumbnail JPEG file
		result = false
		strSearchFileName = strInputFileNameNoExt
		Do While result = false
		 If objFSI.FileExists(strThumbnailFolder & strSearchFileName & strThumbNailFileExt) Then
		  result = true
		 Else
		  If Len(strSearchFileName) > 3 Then
		   strSearchFileName = Left(strSearchFileName,Len(strSearchFileName) - 1) 
		  Else
		   strSearchFileName = strReferenzThumbnail
		   result = true
		  End if
		 End if
		loop
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "Thumbnail strSearchFileName = " & strSearchFileName & Chr(13) & Chr ( 10)
		   objLogText.Close
		End If
		
		Set objInputFile = objFSI.OpenTextFile(strThumbnailFolder & strSearchFileName & strThumbnailFileExt, ForReading)
		strThumbnail = objInputFile.ReadAll
		objInputFile.Close		
		Set objInputFile = Nothing
		lngStrLen = Len(strThumbnail)
		
		lngFileLen = lngStrLen
		strThumbnail = ""
		Set objInputFile = objFSI.OpenTextFile(strThumbnailFolder & strSearchFileName & strThumbnailFileExt, ForReading)
		For i = 1 to lngFileLen
		  strThumbnail = strThumbnail & (objInputFile.Read(1))
		Next
		objInputFile.Close
		
		
		If logena = 1 Then
		   Set objLogText = objFSO.OpenTextFile(strLogPath & strLogFile, ForAppending, True)
		   objLogText.Write "lngStrLen = " & lngStrLen & Chr(13) & Chr ( 10)
		   objLogText.Close
		End If
		
		' add lenght of Thumbnailstring to output file (2 bytes)
		strOutputSVI = strOutputSVI & Chr(lngStrLen - (Int(lngStrLen/256)*256)) & Chr(Int(lngStrLen/256)) & Chr(0) & Chr(0)
		
		' add Thumbnail string
		strOutputSVI = strOutputSVI & strThumbnail
				
	        ' write new SVI file
		Set objOutputFile = objFSO.OpenTextFile(strOutputFile, ForWriting, True)	
		objOutputFile.Write (strOutputSVI)
		objOutputFile.Close
		Set objOutputFile = Nothing
		
		
		
	End If
Next

Set objFSO	= Nothing
Set objFolder	= Nothing
Set colFiles	= Nothing
Set objFile	= Nothing